/** 
 *  Hyper Operating System V4 Advance
 *
 * @file  wup_tsk.c
 * @brief %jp{^XN̋N}%en{Wakeup Task}
 *
 * Copyright (C) 1998-2006 by Project HOS
 * http://sourceforge.jp/projects/hos/
 */



#include "core/core.h"



/* ^XN̏ԎQ */
ER ref_tsk(ID tskid, T_RTSK *p_rtsk)
{
	_KERNEL_T_TSKHDL		tskhdl;
	_KERNEL_T_TCB_PTR		tcb;
	_KERNEL_T_TCB_RO_PTR	tcb_ro;

	if ( tskid == TSK_SELF )		/* %jp{^XNw莞̕ϊ} */
	{
#if _KERNEL_SPT_REF_TSK_E_ID
		if ( _KERNEL_SYS_SNS_CTX() )
		{
			return E_ID;		/* %jp{sIDԍ} */
		}
#endif	
		/* %jp{s^XN擾} */
		tskhdl = _KERNEL_SYS_GET_RUNTSK();

		_KERNEL_ENTER_SVC();		/* %jp{enter service-call}%jp{T[rXR[ɓ} */
	}
	else
	{
#if _KERNEL_SPT_REF_TSK_E_ID
		if ( !_KERNEL_TSK_CHECK_TSKID(tskid) )
		{
			return E_ID;	/* %jp{sIDԍ} */
		}
#endif
		
		_KERNEL_ENTER_SVC();			/* %jp{enter service-call}%jp{T[rXR[ɓ} */
		
		/* %jp{IuWFNg݃`FbN} */
#if _KERNEL_SPT_REF_TSK_E_NOEXS
		if ( !_KERNEL_TSK_CHECK_EXS(tskid) )
		{
			_KERNEL_LEAVE_SVC();		/* %jp{leave service-call}%jp{T[rXR[o} */
			return E_NOEXS;				/* %jp{IuWFNg} */
		}
#endif
		/* IDԍw莞̕ϊ */
		tskhdl = _KERNEL_TSK_ID2TSKHDL(tskid);
	}

	/* %jp{TCB擾} */
	tcb    = _KERNEL_TSK_TSKHDL2TCB(tskhdl);
	tcb_ro = _KERNEL_TSK_GET_TCB_RO(tskid, tcb);
	
	p_rtsk->tskstat = _KERNEL_DEC_TTS(_KERNEL_TSK_GET_TSKSTAT(tcb));	/* %jp{^XN} */
	p_rtsk->tskpri  = _KERNEL_TSK_GET_TSKPRI(tcb);						/* %jp{^XŇݗDx} */
	p_rtsk->tskbpri = _KERNEL_TSK_GET_TSKBPRI(tcb);						/* %jp{^XÑx[XDx} */
	p_rtsk->tskwait = _KERNEL_DEC_TTW(_KERNEL_TSK_GET_TSKWAIT(tcb));	/* %jp{҂v} */
	p_rtsk->wobjid  = _KERNEL_TSK_GET_WOBJID(tcb);						/* %jp{҂Ώۂ̃IuWFNgIDԍ} */
/*	p_rtsk->lefttmo = _KERNEL_TSK_GET_LEFTTMO(tskhdl);	*/				/* %jp{^CAEg܂ł̎} */
	p_rtsk->actcnt  = _KERNEL_TSK_GET_ACTCNT(tcb);						/* %jp{NvL[CO} */
	p_rtsk->wupcnt  = _KERNEL_TSK_GET_WUPCNT(tcb);						/* %jp{NvL[CO} */
	p_rtsk->suscnt  = _KERNEL_TSK_GET_SUSCNT(tcb);						/* %jp{҂vlXg} */
	
	
	/* %jp{ȉAƎ}%en{HOS extention} */
#if _KERNEL_SPT_RTSK_TSKATR
	p_rtsk->tskatr  = _KERNEL_TSK_GET_TSKATR(tcb_ro);					/* %jp{^XN(HOSƎg)} */
#endif

#if _KERNEL_SPT_RTSK_EXINF
	p_rtsk->exinf   = _KERNEL_TSK_GET_EXINF(tcb_ro);					/* %jp{^XN̊g(HOSƎg)} */
#endif

#if _KERNEL_SPT_RTSK_TASK
	p_rtsk->task    = _KERNEL_TSK_GET_TASK(tcb_ro);						/* %jp{^XN̋NԒn(HOSƎg)} */
#endif
#if _KERNEL_SPT_RTSK_ITSKPRI
	p_rtsk->itskpri = _KERNEL_TSK_GET_ITSKPRI(tcb_ro);					/* %jp{^XN̋NDx(HOSƎg)} */
#endif
#if _KERNEL_SPT_RTSK_STKSZ
	p_rtsk->stksz   = _KERNEL_TSK_GET_STKSZ(tcb_ro);					/* %jp{X^bN̈̃TCY(oCg)(HOSƎg)} */
#endif
#if _KERNEL_SPT_RTSK_STK
	p_rtsk->stk     = _KERNEL_TSK_GET_STK(tcb_ro);						/* %jp{X^bN̈̐擪Ԓn(HOSƎg)} */
#endif


	_KERNEL_LEAVE_SVC();	/* %jp{T[rXR[I} */

	return E_OK;
}


/* end of file */
